Index: include/bn.h
===================================================================
--- include/bn.h	(revision 49726)
+++ include/bn.h	(working copy)
@@ -59,11 +59,12 @@
 
 
 /** @} */
+
 /*----------------------------------------------------------------------*/
+
 /** @addtogroup tol */
 /** @{ */
-/**
- * B N _ T O L
+/** B N _ T O L
  *
  * @brief Support for uniform tolerances
  *
@@ -101,6 +102,7 @@
  * tol->dist_sq = tol->dist * tol->dist;
  *@n tol->para = 1 - tol->perp;
  */
+
 struct bn_tol {
     uint32_t magic;
     double dist;		/**< @brief >= 0 */
@@ -153,7 +155,11 @@
 
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* anim.c */
 /** @addtogroup anim */
 /** @{ */
@@ -199,6 +205,12 @@
  */
 BN_EXPORT extern void anim_tran(mat_t m);
 
+
+/***************************************
+ *ANIM_MAT2* - Conversions from matrices
+ ***************************************/
+
+
 /**
  * @brief
  * Convert the rotational part of a 4x4 transformation matrix to zyx
@@ -233,6 +245,12 @@
 BN_EXPORT extern int anim_mat2quat(quat_t quat,
 				   const mat_t viewrot);
 
+
+/***************************************
+ *ANIM_*2MAT - Conversions to matrices
+ ***************************************/
+
+
 /**
  * @brief Create a premultiplication rotation matrix to turn the front
  * of an object (its x-axis) to the given yaw, pitch, and roll, which
@@ -379,6 +397,12 @@
 				    vect_t point,
 				    int end);
 
+
+/***************************************
+ * Other animation routines
+ ***************************************/
+
+
 /**
  * @brief Add pre- and post- translation to a rotation matrix.  The
  * resulting matrix has the effect of performing the first
@@ -420,7 +444,19 @@
 
 
 /*----------------------------------------------------------------------*/
-/* bn_tcl.c */
+
+
+/* tcl.c */
+
+/** @addtogroup bntcl */
+/** @{
+ *
+ * @brief
+ * Tcl interfaces to all the LIBBN math routines.
+ *
+ */
+
+
 BN_EXPORT extern int bn_decode_mat(mat_t m,
 				   const char *str);
 BN_EXPORT extern int bn_decode_quat(quat_t q,
@@ -439,15 +475,41 @@
 				      const hvect_t v);
 
 /* The presence of Tcl_Interp as an arg prevents giving arg list */
+
+/**
+ * B N _ T C L _ S E T U P
+ *@brief
+ * Add all the supported Tcl interfaces to LIBBN routines to
+ * the list of commands known by the given interpreter.
+ */
 BN_EXPORT extern void bn_tcl_setup();
+
+/**
+ * B N _ I N I T
+ *@brief
+ * Allows LIBBN to be dynamically loade to a vanilla tclsh/wish with
+ * "load /usr/brlcad/lib/libbn.so"
+ *
+ * The name of this function is specified by TCL.
+ */
 BN_EXPORT extern int Bn_Init();
+
+/**
+ * B N _ M A T _ P R I N T
+ */
 BN_EXPORT extern void bn_tcl_mat_print();
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* complex.c */
+
 /** @addtogroup complex */
 /** @{ */
+
 /*
  * Complex numbers
  */
@@ -508,22 +570,63 @@
 BN_EXPORT extern void bn_cx_sqrt(bn_complex_t *op,
 				 const bn_complex_t *ip);
 
+
 /*----------------------------------------------------------------------*/
+
+
 /* mat.c */
 /*
  * 4x4 Matrix math
  */
+
+/** @addtogroup mat */
+/** @{
+ *
+ * @brief
+ * 4 x 4 Matrix manipulation functions...
+ *
+ * Matrix array elements have the following positions in the matrix:
+ @code
+ *			|  0  1  2  3 |		| 0 |
+ *	[ 0 1 2 3 ]	|  4  5  6  7 |		| 1 |
+ *			|  8  9 10 11 |		| 2 |
+ *			| 12 13 14 15 |		| 3 |
+ *
+ * preVector (vect_t) Matrix (mat_t) postVector (vect_t)
+ @endcode
+ *
+ * TODO: need a better way to control tolerancing, either via
+ * additional tolerance parameters or perhaps providing a global
+ * tolerance state interface.
+ */
+
+
 BN_EXPORT extern const mat_t bn_mat_identity;
 
+/**
+ * B N _ M A T _ P R I N T
+ */
 BN_EXPORT extern void bn_mat_print(const char *title,
 				   const mat_t m);
+				   
 BN_EXPORT extern void bn_mat_print_guts(const char *title,
 					const mat_t m,
 					char *buf,
 					int buflen);
+					
+/**
+ * B N _ M A T _ P R I N T _ V L S
+ */
 BN_EXPORT extern void bn_mat_print_vls(const char *title,
 				       const mat_t m,
 				       struct bu_vls *vls);
+				       
+/**
+ * B N _ A T A N 2
+ *
+ * A wrapper for the system atan2().  On the Silicon Graphics, and
+ * perhaps on others, x==0 incorrectly returns infinity.
+ */
 BN_EXPORT extern double bn_atan2(double x, double y);
 
 #define bn_mat_zero(_m) { \
@@ -570,62 +673,221 @@
   #define bn_mat_copy(_d, _s)	(void)memcpy((void *)_d, (const void *)(_s), sizeof(mat_t))
 */
 
-
+/**
+ * B N _ M A T _ M U L
+ *
+ * Multiply matrix "a" by "b" and store the result in "o".
+ *
+ * This is different from multiplying "b" by "a" (most of the time!)
+ * Also, "o" must not be the same as either of the inputs.
+ */
 BN_EXPORT extern void bn_mat_mul(mat_t o,
 				 const mat_t a,
 				 const mat_t b);
+				 
+/**
+ * B N _ M A T _ M U L 2
+ *
+ * o = i * o
+ *
+ * A convenience wrapper for bn_mat_mul() to update a matrix in place.
+ * The argument ordering is confusing either way.
+ */
 BN_EXPORT extern void bn_mat_mul2(const mat_t i,
 				  mat_t o);
+				  
+/**
+ * B N _ M A T _ M U L 3
+ *
+ * o = a * b * c
+ *
+ * The output matrix may be the same as 'b' or 'c', but may not be
+ * 'a'.
+ */
 BN_EXPORT extern void bn_mat_mul3(mat_t o,
 				  const mat_t a,
 				  const mat_t b,
 				  const mat_t c);
+				  
+/**
+ * B N _ M A T _ M U L 4
+ *
+ * o = a * b * c * d
+ *
+ * The output matrix may be the same as any input matrix.
+ */
 BN_EXPORT extern void bn_mat_mul4(mat_t o,
 				  const mat_t a,
 				  const mat_t b,
 				  const mat_t c,
 				  const mat_t d);
+				  
+/**
+ * B N _ M A T X V E C
+ *
+ * Multiply the matrix "im" by the vector "iv" and store the result in
+ * the vector "ov".  Note this is post-multiply, and operates on
+ * 4-tuples.  Use MAT4X3VEC() to operate on 3-tuples.
+ */
 BN_EXPORT extern void bn_matXvec(hvect_t ov,
 				 const mat_t im,
 				 const hvect_t iv);
+
+/**
+ * B N _ M A T _ I N V
+ *
+ * The matrix pointed at by "input" is inverted and stored in the area
+ * pointed at by "output".
+ *
+ * Calls bu_bomb if matrix is singular.
+ */				 
 BN_EXPORT extern void bn_mat_inv(mat_t output,
 				 const mat_t input);
+
+/**
+ * B N _ M A T _ I N V E R S E
+ *
+ * The matrix pointed at by "input" is inverted and stored in the area
+ * pointed at by "output".
+ *
+ * Invert a 4-by-4 matrix using Algorithm 120 from ACM.  This is a
+ * modified Gauss-Jordan alogorithm Note: Inversion is done in place,
+ * with 3 work vectors
+ *
+ * @return 1 if OK.
+ * @return 0 if matrix is singular.
+ */				 
 BN_EXPORT extern int bn_mat_inverse(mat_t output,
 				    const mat_t input);
+				    
+/**
+ * B N _ V T O H _ M O V E
+ *
+ * Takes a pointer to a [x, y, z] vector, and a pointer to space for a
+ * homogeneous vector [x, y, z, w], and builds [x, y, z, 1].
+ */
 BN_EXPORT extern void bn_vtoh_move(vect_t h,
 				   const vect_t v);
+				   
+/**
+ * B N _ H T O V _ M O V E
+ *
+ * Takes a pointer to [x, y, z, w], and converts it to an ordinary
+ * vector [x/w, y/w, z/w].  Optimization for the case of w==1 is
+ * performed.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_htov_move(vect_t v,
 				   const vect_t h);
+				   
+/**
+ * B N _ M A T _ T R N
+ */
 BN_EXPORT extern void bn_mat_trn(mat_t om,
 				 const mat_t im);
+				 
+/**
+ * B N _ M A T _ A E
+ *
+ * Compute a 4x4 rotation matrix given Azimuth and Elevation.
+ *
+ * Azimuth is +X, Elevation is +Z, both in degrees.
+ *
+ * Formula due to Doug Gwyn, BRL.
+ */
 BN_EXPORT extern void bn_mat_ae(mat_t m,
 				double azimuth,
 				double elev);
+				
+/**
+ * B N _ A E _ V E C
+ *
+ * Find the azimuth and elevation angles that correspond to the
+ * direction (not including twist) given by a direction vector.
+ */
 BN_EXPORT extern void bn_ae_vec(fastf_t *azp,
 				fastf_t *elp,
 				const vect_t v);
+				
+/**
+ * B N _ A E T _ V E C
+ *
+ * Find the azimuth, elevation, and twist from two vectors.  Vec_ae is
+ * in the direction of view (+z in mged view) and vec_twist points to
+ * the viewers right (+x in mged view).  Accuracy (degrees) is used to
+ * stabilze flutter between equivalent extremes of atan2(), and to
+ * snap twist to zero when elevation is near +/- 90
+ */
 BN_EXPORT extern void bn_aet_vec(fastf_t *az,
 				 fastf_t *el,
 				 fastf_t *twist,
 				 vect_t vec_ae,
 				 vect_t vec_twist,
 				 fastf_t accuracy);
+				 
+/**
+ * B N _ V E C _ A E
+ *
+ * Find a unit vector from the origin given azimuth and elevation.
+ */
 BN_EXPORT extern void bn_vec_ae(vect_t vec,
 				fastf_t az,
 				fastf_t el);
+				
+/**
+ * B N _ V E C _ A E D
+ *
+ * Find a vector from the origin given azimuth, elevation, and distance.
+ */
 BN_EXPORT extern void bn_vec_aed(vect_t vec,
 				 fastf_t az,
 				 fastf_t el,
 				 fastf_t dist);
 
+/**
+ * B N _ M A T _ A N G L E S
+ *
+ * This routine builds a Homogeneous rotation matrix, given alpha,
+ * beta, and gamma as angles of rotation, in degrees.
+ *
+ * Alpha is angle of rotation about the X axis, and is done third.
+ * Beta is angle of rotation about the Y axis, and is done second.
+ * Gamma is angle of rotation about Z axis, and is done first.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_mat_angles(mat_t mat,
 				    double alpha,
 				    double beta, double ggamma);
+				    
+/**
+ * B N _ M A T _ A N G L E S _ R A D
+ *
+ * This routine builds a Homogeneous rotation matrix, given alpha,
+ * beta, and gamma as angles of rotation, in radians.
+ *
+ * Alpha is angle of rotation about the X axis, and is done third.
+ * Beta is angle of rotation about the Y axis, and is done second.
+ * Gamma is angle of rotation about Z axis, and is done first.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_mat_angles_rad(mat_t mat,
 					double alpha,
 					double beta,
 					double ggamma);
 
+/**
+ * B N _ E I G E N 2 X 2
+ *
+ * Find the eigenvalues and eigenvectors of a symmetric 2x2 matrix.
+ * (a b)
+ * (b c)
+ *
+ * The eigenvalue with the smallest absolute value is returned in
+ * val1, with its eigenvector in vec1.
+ */
 BN_EXPORT extern void bn_eigen2x2(fastf_t *val1,
 				  fastf_t *val2,
 				  vect_t vec1,
@@ -634,47 +896,216 @@
 				  fastf_t b,
 				  fastf_t c);
 
+/**
+ * B N _ V E C _ P E R P
+ *
+ * Given a vector, create another vector which is perpendicular to it.
+ * The output vector will have unit length only if the input vector
+ * did.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_vec_perp(vect_t new_vec,
 				  const vect_t old_vec);
+				  
+/**
+ * B N _ M A T _ F R O M T O
+ *
+ * Given two vectors, compute a rotation matrix that will transform
+ * space by the angle between the two.  There are many candidate
+ * matricies.
+ *
+ * The input 'from' and 'to' vectors need not be unit length.
+ * MAT4X3VEC(to, m, from) is the identity that is created.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_mat_fromto(mat_t m,
 				    const vect_t from,
 				    const vect_t to);
+				    
+/**
+ * B N _ M A T _ X R O T
+ *
+ * Given the sin and cos of an X rotation angle, produce the rotation
+ * matrix.
+ */
 BN_EXPORT extern void bn_mat_xrot(mat_t m,
 				  double sinx,
 				  double cosx);
+				  
+/**
+ * B N _ M A T _ Y R O T
+ *
+ * Given the sin and cos of a Y rotation angle, produce the rotation
+ * matrix.
+ */
 BN_EXPORT extern void bn_mat_yrot(mat_t m,
 				  double siny,
 				  double cosy);
+				  
+/**
+ * B N _ M A T _ Z R O T
+ *
+ * Given the sin and cos of a Z rotation angle, produce the rotation
+ * matrix.
+ */
 BN_EXPORT extern void bn_mat_zrot(mat_t m,
 				  double sinz,
 				  double cosz);
+				  
+/**
+ * B N _ M A T _ L O O K A T
+ *
+ * Given a direction vector D of unit length, product a matrix which
+ * rotates that vector D onto the -Z axis.  This matrix will be
+ * suitable for use as a "model2view" matrix.
+ *
+ * XXX This routine will fail if the vector is already more or less
+ * aligned with the Z axis.
+ *
+ * This is done in several steps.
+ *
+ @code
+ 1) Rotate D about Z to match +X axis.  Azimuth adjustment.
+ 2) Rotate D about Y to match -Y axis.  Elevation adjustment.
+ 3) Rotate D about Z to make projection of X axis again point
+ in the +X direction.  Twist adjustment.
+ 4) Optionally, flip sign on Y axis if original Z becomes inverted.
+ This can be nice for static frames, but is astonishing when
+ used in animation.
+ @endcode
+*/
 BN_EXPORT extern void bn_mat_lookat(mat_t rot,
 				    const vect_t dir,
 				    int yflip);
+				    
+/**
+ * B N _ V E C _ O R T H O
+ *
+ * Given a vector, create another vector which is perpendicular to it,
+ * and with unit length.  This algorithm taken from Gift's arvec.f; a
+ * faster algorithm may be possible.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_vec_ortho(vect_t out,
 				   const vect_t in);
+				   
+/**
+ * B N _ M A T _ S C A L E _ A B O U T _ P T
+ *
+ * Build a matrix to scale uniformly around a given point.
+ *
+ * @return -1 if scale is too small.
+ * @return  0 if OK.
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern int bn_mat_scale_about_pt(mat_t mat,
 					   const point_t pt,
 					   const double scale);
+					   
+/**
+ * B N _ M A T _ X F O R M _ A B O U T _ P T
+ *
+ * Build a matrix to apply arbitary 4x4 transformation around a given
+ * point.
+ */
 BN_EXPORT extern void bn_mat_xform_about_pt(mat_t mat,
 					    const mat_t xform,
 					    const point_t pt);
+					    
+/**
+ * B N _ M A T _ I S _ E Q U A L
+ *
+ * @return 0 When matrices are not equal
+ * @return 1 When matricies are equal
+ */
 BN_EXPORT extern int bn_mat_is_equal(const mat_t a,
 				     const mat_t b,
 				     const struct bn_tol *tol);
+				     
+/**
+ * B N _ M A T _ I S _ I D E N T I T Y
+ *
+ * This routine is intended for detecting identity matricies read in
+ * from ascii or binary files, where the numbers are pure ones or
+ * zeros.  This routine is *not* intended for tolerance-based
+ * "near-zero" comparisons; as such, it shouldn't be used on matrices
+ * which are the result of calculation.
+ *
+ *
+ * @return 0 non-identity
+ * @return 1 a perfect identity matrix
+ */
 BN_EXPORT extern int bn_mat_is_identity(const mat_t m);
+
+/**
+ * B N _ M A T _ A R B _ R O T
+ *
+ * Construct a transformation matrix for rotation about an arbitrary
+ * axis.  The axis is defined by a point (pt) and a unit direction
+ * vector (dir).  The angle of rotation is "ang"
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern void bn_mat_arb_rot(mat_t m,
 				     const point_t pt,
 				     const vect_t dir,
 				     const fastf_t ang);
+				     
+/**
+ * B N _ M A T _ D U P
+ *
+ * Return a pointer to a copy of the matrix in dynamically allocated
+ * memory.
+ */
 BN_EXPORT extern matp_t bn_mat_dup(const mat_t in);
+
+/**
+ * B N _ M A T _ C K
+ *
+ * Check to ensure that a rotation matrix preserves axis
+ * perpendicularily.  Note that not all matricies are rotation
+ * matricies.
+ *
+ *
+ * @return -1 FAIL
+ * @return  0 OK
+ */
 BN_EXPORT extern int bn_mat_ck(const char *title,
 			       const mat_t m);
+			       
+/**
+ * B N _ M A T _ D E T 3
+ *
+ * Calculates the determinant of the 3X3 "rotation" part of the passed
+ * matrix.
+ */
 BN_EXPORT extern fastf_t bn_mat_det3(const mat_t m);
+
+/**
+ * B N _ M A T _ D E T E R M I N A N T
+ *
+ * Calculates the determinant of the 4X4 matrix
+ */
 BN_EXPORT extern fastf_t bn_mat_determinant(const mat_t m);
 
+/**
+ * B N _ M A T _ I S _ N O N _ U N I F
+ *
+ * FIXME: make tolerance configurable
+ */
 BN_EXPORT extern int bn_mat_is_non_unif(const mat_t m);
 
+/**
+ * B N _ W R T _ P O I N T _ D I R E C
+ *
+ * Given a model-space transformation matrix "change",
+ * return a matrix which applies the change with-respect-to
+ * given "point" and "direc".
+ */
 BN_EXPORT extern void bn_wrt_point_direc(mat_t out,
 					 const mat_t change,
 					 const mat_t in,
@@ -682,10 +1113,25 @@
 					 const vect_t direc);
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* msr.c */
 /** @addtogroup msr */
-/** @{ */
+/** @{
+ *
+ * @brief
+ * Minimal Standard RANdom number generator
+ *
+ * @par From:
+ *	Stephen K. Park and Keith W. Miller
+ * @n	"Random number generators: good ones are hard to find"
+ * @n	CACM vol 31 no 10, Oct 88
+ *
+ */
+
 /*
  * Define data structures and constants for the "MSR" random number
  * package.
@@ -721,14 +1167,163 @@
     double *msr_gausses;
 };
 
+
+/*	bn_unif_init	Initialize a random number structure.
+ *
+ * @par Entry
+ *	setseed	seed to use
+ *	method  method to use to generate numbers;
+ *
+ * @par Exit
+ *	returns	a pointer to a bn_unif structure.
+ *	returns 0 on error.
+ *
+ * @par Uses
+ *	None.
+ *
+ * @par Calls
+ *	bu_malloc
+ *
+ * @par Method @code
+ *	malloc up a structure with pointers to the numbers
+ *	get space for the integer table.
+ *	get space for the floating table.
+ *	set pointer counters
+ *	set seed if one was given and setseed != 1
+ @endcode
+ *
+ */
 BN_EXPORT extern struct bn_unif *bn_unif_init(long setseed,
 					      int method);
+      
+/*	bn_unif_free	free random number table
+ *
+ */
 BN_EXPORT extern void bn_unif_free(struct bn_unif *p);
+
+/*	bn_unif_long_fill	fill a random number table.
+ *
+ * Use the msrad algorithm to fill a random number table
+ * with values from 1 to 2^31-1.  These numbers can (and are) extracted from
+ * the random number table via high speed macros and bn_unif_long_fill called
+ * when the table is exauseted.
+ *
+ * @par Entry
+ *	p	pointer to a bn_unif structure.
+ *
+ * @par Exit
+ *	if (!p) returns 1 else returns a value between 1 and 2^31-1
+ *
+ * @par Calls
+ *	None.  msran is inlined for speed reasons.
+ *
+ * @par Uses
+ *	None.
+ *
+ * @par Method @code
+ *	if (!p) return 1;
+ *	if p->msr_longs != NULL
+ *		msr_longs is reloaded with random numbers;
+ *		msr_long_ptr is set to BN_MSR_MAXTBL
+ *	endif
+ *	msr_seed is updated.
+ @endcode
+*/
 BN_EXPORT extern long bn_unif_long_fill(struct bn_unif *p);
+
+/*	bn_unif_double_fill	fill a random number table.
+ *
+ * Use the msrad algorithm to fill a random number table
+ * with values from -0.5 to 0.5.  These numbers can (and are) extracted from
+ * the random number table via high speed macros and bn_unif_double_fill
+ * called when the table is exauseted.
+ *
+ * @par Entry
+ *	p	pointer to a bn_unif structure.
+ *
+ * @par Exit
+ *	if (!p) returns 0.0 else returns a value between -0.5 and 0.5
+ *
+ * @par Calls
+ *	None.  msran is inlined for speed reasons.
+ *
+ * @par Uses
+ *	None.
+ *
+ * @par Method @code
+ *	if (!p) return (0.0)
+ *	if p->msr_longs != NULL
+ *		msr_longs is reloaded with random numbers;
+ *		msr_long_ptr is set to BN_MSR_MAXTBL
+ *	endif
+ *	msr_seed is updated.
+ @endcode
+*/
 BN_EXPORT extern double bn_unif_double_fill(struct bn_unif *p);
+
+/*	bn_gauss_init	Initialize a random number struct for gaussian
+ *	numbers.
+ *
+ * @par Entry
+ *	setseed		Seed to use.
+ *	method		method to use to generate numbers (not used)
+ *
+ * @par Exit
+ *	Returns a pointer toa bn_msr_guass structure.
+ *	returns 0 on error.
+ *
+ * @par Calls
+ *	bu_malloc
+ *
+ * @par Uses
+ *	None.
+ *
+ * @par Method @code
+ *	malloc up a structure
+ *	get table space
+ *	set seed and pointer.
+ *	if setseed != 0 then seed = setseed
+ @endcode
+*/
 BN_EXPORT extern struct bn_gauss *bn_gauss_init(long setseed,
 						int method);
+						
+/*	bn_gauss_free	free random number table
+ *
+ */
 BN_EXPORT extern void bn_gauss_free(struct bn_gauss *p);
+
+/*	bn_gauss_fill	fill a random number table.
+ *
+ * Use the msrad algorithm to fill a random number table.
+ * hese numbers can (and are) extracted from
+ * the random number table via high speed macros and bn_msr_guass_fill
+ * called when the table is exauseted.
+ *
+ * @par Entry
+ *	p	pointer to a bn_msr_guass structure.
+ *
+ * @par Exit
+ *	if (!p) returns 0.0 else returns a value with a mean of 0 and
+ *	    a variance of 1.0.
+ *
+ * @par Calls
+ *	BN_UNIF_CIRCLE to get to uniform random number whos radius is
+ *	<= 1.0. I.e. sqrt(v1*v1 + v2*v2) <= 1.0
+ *	BN_UNIF_CIRCLE is a macro which can call bn_unif_double_fill.
+ *
+ * @par Uses
+ *	None.
+ *
+ * @par Method @code
+ *	if (!p) return (0.0)
+ *	if p->msr_longs != NULL
+ *		msr_longs is reloaded with random numbers;
+ *		msr_long_ptr is set to BN_MSR_MAXTBL
+ *	endif
+ *	msr_seed is updated.
+ @endcode
+*/
 BN_EXPORT extern double bn_gauss_fill(struct bn_gauss *p);
 
 #define BN_UNIF_LONG(_p)	\
@@ -761,45 +1356,180 @@
      bn_gauss_fill(_p))
 
 /** @} */
+
+
 /*----------------------------------------------------------------------*/
+
+
 /* noise.c */
+
 /* @addtogroup noise */
-/** @{ */
+/** @{
+ *
+ * These noise functions provide mostly random noise at the integer
+ * lattice points.  The functions should be evaluated at non-integer
+ * locations for their nature to be realized.
+ *
+ * Conatins contributed code from:
+ * F. Kenton Musgrave
+ * Robert Skinner
+ *
+ */
+
 /*
  * fractal noise support
  */
 
+
 BN_EXPORT extern void bn_noise_init();
+
+/**
+ *@brief
+ * Robert Skinner's Perlin-style "Noise" function
+ *
+ * Results are in the range [-0.5 .. 0.5].  Unlike many
+ * implementations, this function provides random noise at the integer
+ * lattice values.  However this produces much poorer quality and
+ * should be avoided if possible.
+ *
+ * The power distribution of the result has no particular shape,
+ * though it isn't as flat as the literature would have one believe.
+ */
 BN_EXPORT extern double bn_noise_perlin(point_t pt);
-/* FIXME: Why isn't the result listed first? */
+
+/**
+ * Vector-valued "Noise"
+ */
 BN_EXPORT extern void bn_noise_vec(point_t point,
 				   point_t result);
+
+/**
+ * @brief
+ * Procedural fBm evaluated at "point"; returns value stored in
+ * "value".
+ *
+ * @param point          location to sample noise
+ * @param ``h_val''      fractal increment parameter
+ * @param ``lacunarity'' gap between successive frequencies
+ * @param ``octaves''  	 number of frequencies in the fBm
+ *
+ * The spectral properties of the result are in the APPROXIMATE range
+ * [-1..1] Depending upon the number of octaves computed, this range
+ * may be exceeded.  Applications should clamp or scale the result to
+ * their needs.  The results have a more-or-less gaussian
+ * distribution.  Typical results for 1M samples include:
+ *
+ * @li Min -1.15246
+ * @li Max  1.23146
+ * @li Mean -0.0138744
+ * @li s.d.  0.306642
+ * @li Var 0.0940295
+ *
+ * The function call pow() is relatively expensive.  Therfore, this
+ * function pre-computes and saves the spectral weights in a table for
+ * re-use in successive invocations.
+ */
 BN_EXPORT extern double bn_noise_fbm(point_t point,
 				     double h_val,
 				     double lacunarity,
 				     double octaves);
+
+/**
+ * @brief
+ * Procedural turbulence evaluated at "point";
+ *
+ * @return turbulence value for point
+ *
+ * @param point          location to sample noise at
+ * @param ``h_val''      fractal increment parameter
+ * @param ``lacunarity'' gap between successive frequencies
+ * @param ``octaves''    number of frequencies in the fBm
+ *
+ * The result is characterized by sharp, narrow trenches in low values
+ * and a more fbm-like quality in the mid-high values.  Values are in
+ * the APPROXIMATE range [0 .. 1] depending upon the number of octaves
+ * evaluated.  Typical results:
+ @code
+ * Min  0.00857137
+ * Max  1.26712
+ * Mean 0.395122
+ * s.d. 0.174796
+ * Var  0.0305536
+ @endcode
+ * The function call pow() is relatively expensive.  Therfore, this
+ * function pre-computes and saves the spectral weights in a table for
+ * re-use in successive invocations.
+ */
 BN_EXPORT extern double bn_noise_turb(point_t point,
 				      double h_val,
 				      double lacunarity,
 				      double octaves);
+
+/**
+ *
+ * From "Texturing and Modeling, A Procedural Approach" 2nd ed
+ */
 BN_EXPORT extern double bn_noise_mf(point_t point,
 				    double h_val,
 				    double lacunarity,
 				    double octaves,
 				    double offset);
+
+/**
+ *@brief
+ * A ridged noise pattern
+ *
+ * From "Texturing and Modeling, A Procedural Approach" 2nd ed p338
+ */
 BN_EXPORT extern double bn_noise_ridged(point_t point,
 					double h_val,
 					double lacunarity,
 					double octaves,
 					double offset);
 
+
 /*----------------------------------------------------------------------*/
+
+
 /* plane.c */
 /*
  * Plane/line/point calculations
  */
 
+/** @addtogroup plane */
+/** @{
+ *
+ * @brief
+ * Some useful routines for dealing with planes and lines.
+ *
+ */
 
+
+
+/** B N _ D I S T S Q _ L I N E 3 _ L I N E 3
+ *@brief
+ * Calculate the square of the distance of closest approach for two
+ * lines.
+ *
+ * The lines are specifed as a point and a vector each.  The vectors
+ * need not be unit length.  P and d define one line; Q and e define
+ * the other.
+ *
+ * @return 0 - normal return
+ * @return 1 - lines are parallel, dist[0] is set to 0.0
+ *
+ * Output values:
+ * dist[0] is the parametric distance along the first line P + dist[0] * d of the PCA
+ * dist[1] is the parametric distance along the second line Q + dist[1] * e of the PCA
+ * dist[3] is the square of the distance between the points of closest approach
+ * pt1 is the point of closest approach on the first line
+ * pt2 is the point of closest approach on the second line
+ *
+ * This algoritm is based on expressing the distance sqaured, taking
+ * partials with respect to the two unknown parameters (dist[0] and
+ * dist[1]), seeting the two partails equal to 0, and solving the two
+ * simutaneous equations
+ */
 BN_EXPORT extern int bn_distsq_line3_line3(fastf_t dist[3],
 					   point_t P,
 					   vect_t d,
@@ -808,6 +1538,31 @@
 					   point_t pt1,
 					   point_t pt2);
 
+/**
+ * Find the distance from a point P to a line described by the
+ * endpoint A and direction dir, and the point of closest approach
+ * (PCA).
+ *
+ @code
+ 			P
+ 		       *
+ 		      /.
+ 		     / .
+ 		    /  .
+ 		   /   . (dist)
+ 		  /    .
+ 		 /     .
+ 		*------*-------->
+ 		A      PCA    dir
+ @endcode
+ * There are three distinct cases, with these return codes -
+ *   0 => P is within tolerance of point A.  *dist = 0, pca=A.
+ *   1 => P is within tolerance of line.  *dist = 0, pca=computed.
+ *   2 => P is "above/below" line.  *dist=|PCA-P|, pca=computed.
+ *
+ * TODO: For efficiency, a version of this routine that provides the
+ * distance squared would be faster.
+ */
 BN_EXPORT extern int bn_dist_pt3_line3(fastf_t *dist,
 				       point_t pca,
 				       const point_t a,
@@ -815,6 +1570,27 @@
 				       const vect_t dir,
 				       const struct bn_tol *tol);
 
+/**
+ * calculate intersection or closest approach of a line and a line
+ * segement.
+ *
+ * returns:
+ *	-2 -> line and line segment are parallel and collinear.
+ *	-1 -> line and line segment are parallel, not collinear.
+ *	 0 -> intersection between points a and b.
+ *	 1 -> intersection outside a and b.
+ *	 2 -> closest approach is between a and b.
+ *	 3 -> closest approach is outside a and b.
+ *
+ * dist[0] is actual distance from p in d direction to
+ * closest portion of segment.
+ * dist[1] is ratio of distance from a to b (0.0 at a, and 1.0 at b),
+ * dist[1] may be less than 0 or greater than 1.
+ * For return values less than 0, closest approach is defined as
+ * closest to point p.
+ * Direction vector, d, must be unit length.
+ *
+ */
 BN_EXPORT extern int bn_dist_line3_lseg3(fastf_t *dist,
 					 const fastf_t *p,
 					 const fastf_t *d,
@@ -822,6 +1598,25 @@
 					 const fastf_t *b,
 					 const struct bn_tol *tol);
 
+/**
+ * Calculate closest approach of two lines
+ *
+ * returns:
+ *	-2 -> lines are parallel and do not intersect
+ *	-1 -> lines are parallel and collinear
+ *	 0 -> lines intersect
+ *	 1 -> lines do not intersect
+ *
+ * For return values less than zero, dist is not set.  For return
+ * valuse of 0 or 1, dist[0] is the distance from p1 in the d1
+ * direction to the point of closest approach for that line.  Similar
+ * for the second line.  d1 and d2 must be unit direction vectors.
+ *
+ * XXX How is this different from bn_isect_line3_line3() ?
+ * XXX Why are the calling sequences just slightly different?
+ * XXX Can we pick the better one, and get rid of the other one?
+ * XXX If not, can we document how they differ?
+ */
 BN_EXPORT extern int bn_dist_line3_line3(fastf_t dist[2],
 					 const point_t p1,
 					 const point_t p2,
